﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ContainerShip
{
    internal class MapsCollection
    {
        readonly Dictionary<string, MapWithSetShipGeneric<DrawingObjectShip, AbstractMap>> _mapStorages;        
        public List<string> Keys => _mapStorages.Keys.ToList();
       
        private readonly int _pictureWidth;
        
        private readonly int _pictureHeight;
        
        public MapsCollection(int pictureWidth, int pictureHeight)
        {
            _mapStorages = new Dictionary<string, MapWithSetShipGeneric<DrawingObjectShip, AbstractMap>>();
            _pictureWidth = pictureWidth;
            _pictureHeight = pictureHeight;
        }
        
        public void AddMap(string name, AbstractMap map)
        {
            if (_mapStorages.ContainsKey(name))
            {
                return;
            }
            MapWithSetShipGeneric<DrawingObjectShip, AbstractMap> newMap = new(_pictureWidth, _pictureHeight, map);
            _mapStorages.Add(name, newMap);
        }
        
        public void DelMap(string name)
        {
            if (_mapStorages.ContainsKey(name))
            {
                _mapStorages.Remove(name);
            }
        }
        
        public MapWithSetShipGeneric<DrawingObjectShip, AbstractMap> this[string
       ind]
        {
            get
            {
                if (_mapStorages.ContainsKey(ind))
                {
                    return _mapStorages[ind];
                }
                return null;
            }
        }
    }
}
